/**
 *
 * Created by Kyle Benk kylebenkapps.com
 *
 * 12/13
 */

jQuery(document).ready(function($) {

	// Color Picker

	$('.color_input').wpColorPicker();

	// Iconpicker

	$('button[role="iconpicker"]').iconpicker().iconpicker('setCols', 10).iconpicker('setRows', 5);

	// Tabs

	$('#myTab a').click(function (e) {
	  e.preventDefault();
	  $(this).tab('show');
	})
	$('#myTab a:first').tab('show');

	/**
	 *
	 * Real-time validation for required fields
	 *
	 */

	$("#" + wps_ff_data.prefix_dash + "name").keyup(function(){
		if ($(this).val() != '') {
			$(this).parent('div').parent('div').removeClass('has-error has-feedback');
			$(this).parent('div').find('.glyphicon-remove').remove();
		} else {
			$(this).parent('div').parent('div').addClass('has-error has-feedback');
			$(this).parent('div').append('<span class="glyphicon glyphicon-remove form-control-feedback"></span>');
		}
	});

	// Datetimepicker

	$('#' + wps_ff_data.prefix_dash + 'start-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + wps_ff_data.prefix_dash + 'end-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + wps_ff_data.prefix_dash + 'end-datepicker')
		.data("DateTimePicker")
		.minDate( $('#' + wps_ff_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

	$('#' + wps_ff_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
       $('#' + wps_ff_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
    });

    $('#' + wps_ff_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
       $('#' + wps_ff_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
    });

	// Form submit preventDefault() if required values are not satisfied

	$("#" + wps_ff_data.prefix_dash + "form").submit(function(e){

		if ($("#" + wps_ff_data.prefix_dash + "name").val() == '') {
			e.preventDefault();
		}
	});

	// Background Image

	$('#' + wps_ff_data.prefix_dash + 'background-image-btn').click(function(e) {
	    e.preventDefault();

		var custom_uploader = wp.media()

	    .on('select', function() {
	        var attachment = custom_uploader.state().get('selection').first().toJSON();
	        $('#' + wps_ff_data.prefix_dash + 'background-image-show').css('background-image', 'url(' + attachment.url + ')');
	        $('#' + wps_ff_data.prefix_dash + 'background-image').val(attachment.id);
	    })
	    .open();
	});

	$('#' + wps_ff_data.prefix_dash + 'background-image-btn-remove').click(function(){
		$('#' + wps_ff_data.prefix_dash + 'background-image-show').css('background-image', '');
	    $('#' + wps_ff_data.prefix_dash + 'background-image').val('');
	});

	// Background Type

	$("." + wps_ff_data.prefix_dash + "background-type").hide();
	$("." + wps_ff_data.prefix_dash + "background-type-" + $("select[name='" + wps_ff_data.prefix_dash + "background-type']").val()).show();

 	$("select[name='" + wps_ff_data.prefix_dash + "background-type']").change(function() {
 		$("." + wps_ff_data.prefix_dash + "background-type").hide();
 		$("." + wps_ff_data.prefix_dash + "background-type-" + $(this).val()).show();
	});

	// Content Type Select button

	$("." + wps_ff_data.prefix_dash + "loction-inner-button").click(function(){

		$("." + wps_ff_data.prefix_dash + "location-button").removeClass('active');
		$("input[name='" + wps_ff_data.prefix_dash + "location']").prop('checked', false);

		$(this).parent('div').parent('div').addClass('active');
		$(this).parent('div').parent('div').find("input[name='" + wps_ff_data.prefix_dash + "location']").prop('checked', true);
		$(this).parent('div').parent('div').find("input[name='" + wps_ff_data.prefix_dash + "location']").trigger('change');
	});

	// Close button

	$("." + wps_ff_data.prefix_dash + "dont-show-again").hide();
	$("." + wps_ff_data.prefix_dash + "icon").hide();

	if ( $("." + wps_ff_data.prefix_dash + "close-button").prop('checked') ) {
		$("." + wps_ff_data.prefix_dash + "dont-show-again").show();
	} else {
		$("." + wps_ff_data.prefix_dash + "icon").show();
	}

	$("." + wps_ff_data.prefix_dash + "close-button").change(function(){
		$("." + wps_ff_data.prefix_dash + "dont-show-again").hide();
		$("." + wps_ff_data.prefix_dash + "icon").hide();

		if ( $(this).prop('checked') ) {
			$("." + wps_ff_data.prefix_dash + "dont-show-again").show();
		} else {
			$("." + wps_ff_data.prefix_dash + "icon").show();
		}
	});

	// Enable and Disable Locations based of Full Height / Width box

	$("input[name='" + wps_ff_data.prefix_dash + "full']").change(function(){

		if ($(this).val() == 'yes') {

			$("." + wps_ff_data.prefix_dash + "push-pull").show();

			$("." + wps_ff_data.prefix_dash + "location-button").removeClass('active');
			$("input[name='" + wps_ff_data.prefix_dash + "location']").prop('checked', false);

			$("#" + wps_ff_data.prefix_dash + "location-2").parent('div').addClass('active');
			$("#" + wps_ff_data.prefix_dash + "location-2").prop('checked', true);
			$("#" + wps_ff_data.prefix_dash + "location-2").trigger('change');

			$("#" + wps_ff_data.prefix_dash + "location-1").parent('div').addClass('disabled');
			$("#" + wps_ff_data.prefix_dash + "location-3").parent('div').addClass('disabled');
			$("#" + wps_ff_data.prefix_dash + "location-7").parent('div').addClass('disabled');
			$("#" + wps_ff_data.prefix_dash + "location-9").parent('div').addClass('disabled');

			$("#" + wps_ff_data.prefix_dash + "location-1").parent('div').css('border', 'none');
			$("#" + wps_ff_data.prefix_dash + "location-3").parent('div').css('border', 'none');
			$("#" + wps_ff_data.prefix_dash + "location-7").parent('div').css('border', 'none');
			$("#" + wps_ff_data.prefix_dash + "location-9").parent('div').css('border', 'none');

		} else {

			$("." + wps_ff_data.prefix_dash + "push-pull").hide();

			$("#" + wps_ff_data.prefix_dash + "location-1").parent('div').removeClass('disabled');
			$("#" + wps_ff_data.prefix_dash + "location-3").parent('div').removeClass('disabled');
			$("#" + wps_ff_data.prefix_dash + "location-7").parent('div').removeClass('disabled');
			$("#" + wps_ff_data.prefix_dash + "location-9").parent('div').removeClass('disabled');

			$("#" + wps_ff_data.prefix_dash + "location-1").parent('div').css('border', '1px solid #ccc');
			$("#" + wps_ff_data.prefix_dash + "location-3").parent('div').css('border', '1px solid #ccc');
			$("#" + wps_ff_data.prefix_dash + "location-7").parent('div').css('border', '1px solid #ccc');
			$("#" + wps_ff_data.prefix_dash + "location-9").parent('div').css('border', '1px solid #ccc');

		}

	});

	if ($("input[name='" + wps_ff_data.prefix_dash + "full']:checked").val() == 'yes') {

		$("." + wps_ff_data.prefix_dash + "push-pull").show();

		$("#" + wps_ff_data.prefix_dash + "location-1").parent('div').addClass('disabled');
		$("#" + wps_ff_data.prefix_dash + "location-3").parent('div').addClass('disabled');
		$("#" + wps_ff_data.prefix_dash + "location-7").parent('div').addClass('disabled');
		$("#" + wps_ff_data.prefix_dash + "location-9").parent('div').addClass('disabled');

		$("#" + wps_ff_data.prefix_dash + "location-1").parent('div').css('border', 'none');
		$("#" + wps_ff_data.prefix_dash + "location-3").parent('div').css('border', 'none');
		$("#" + wps_ff_data.prefix_dash + "location-7").parent('div').css('border', 'none');
		$("#" + wps_ff_data.prefix_dash + "location-9").parent('div').css('border', 'none');

	} else {

		$("." + wps_ff_data.prefix_dash + "push-pull").hide();

	}

	// Hide or show settings based on what user has selected

	$("." + wps_ff_data.prefix_dash + "template").hide();
	$("." + wps_ff_data.prefix_dash + "template-" + $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val()).show();

 	$("input[name='" + wps_ff_data.prefix_dash + "template']").change(function() {
 		$("." + wps_ff_data.prefix_dash + "template").hide();
 		$("." + wps_ff_data.prefix_dash + "template-" + $(this).val()).show();

 		// Show and Hide Newsletter settings

 		$('.' + wps_ff_data.prefix_dash + 'news-letter-WordPress-div').hide();
 		$('.' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-getresponse-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-madmimi-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-mymail-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-feedburner-div').hide();

		if ($("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {

			if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'WordPress') {
				$('.' + wps_ff_data.prefix_dash + 'news-letter-WordPress-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'MailChimp') {
				$('.' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'aweber') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'getresponse') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-getresponse-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'campaignmonitor') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'madmimi') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-madmimi-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'infusionsoft') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'mymail') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-mymail-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'activecampaign') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-div').show();
		  	}

		  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'feedburner') {

			  	$('.' + wps_ff_data.prefix_dash + 'news-letter-feedburner-div').show();
		  	}
		}
	});

  	// Text Link

  	$('#' + wps_ff_data.prefix_dash + 'link-type').change(function(){
  		$('.' + wps_ff_data.prefix_dash + 'text-link-button').hide();

		if ($(this).val() == 'button') {
			$('.' + wps_ff_data.prefix_dash + 'text-link-button').show();
		}
  	});

  	// Trigger Type

	$("." + wps_ff_data.prefix_dash + "trigger-args-type").hide();
	$("." + wps_ff_data.prefix_dash + "trigger-args-type-" + $("select[name='" + wps_ff_data.prefix_dash + "trigger-args-type']").val()).show();

 	$("select[name='" + wps_ff_data.prefix_dash + "trigger-args-type']").change(function() {
 		$("." + wps_ff_data.prefix_dash + "trigger-args-type").hide();
 		$("." + wps_ff_data.prefix_dash + "trigger-args-type-" + $(this).val()).show();
	});

	// User Roles

	$("." + wps_ff_data.prefix_dash + "trigger-args-users").hide();
	$("." + wps_ff_data.prefix_dash + "trigger-args-users-" + $("#" + wps_ff_data.prefix_dash + "trigger-args-users").val()).show();

 	$("#" + wps_ff_data.prefix_dash + "trigger-args-users").change(function() {
 		$("." + wps_ff_data.prefix_dash + "trigger-args-users").hide();
 		$("." + wps_ff_data.prefix_dash + "trigger-args-users-" + $(this).val()).show();

 	});

 	// URL Referrer

	$("." + wps_ff_data.prefix_dash + "trigger-args-referrer").hide();
	$("." + wps_ff_data.prefix_dash + "trigger-args-referrer-" + $("#" + wps_ff_data.prefix_dash + "trigger-args-referrer-type").val()).show();

 	$("#" + wps_ff_data.prefix_dash + "trigger-args-referrer-type").change(function() {
 		$("." + wps_ff_data.prefix_dash + "trigger-args-referrer").hide();
 		$("." + wps_ff_data.prefix_dash + "trigger-args-referrer-" + $(this).val()).show();

 	});

  	// News Letters

  	// Connect Aweber account

    $("." + wps_ff_data.prefix_dash + "aweber-connect").click(function(e){
	    //e.preventDefault();
		//window.location = $(this).attr('data-url') + $("#" + wps_ff_data.prefix_dash + 'news-letter-aweber-code').val();
    });

	$('#' + wps_ff_data.prefix_dash + 'news-letter-type').change(function() {

		$('.' + wps_ff_data.prefix_dash + 'news-letter-WordPress-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-getresponse-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-madmimi-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-mymail-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-div').hide();
		$('.' + wps_ff_data.prefix_dash + 'news-letter-feedburner-div').hide();

		if ($(this).val() == 'WordPress' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
			$('.' + wps_ff_data.prefix_dash + 'news-letter-WordPress-div').show();
		}

	  	else if ($(this).val() == 'MailChimp' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
			$('.' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-div').show();
	  	}

	  	else if ($(this).val() == 'aweber' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-div').show();
	  	}

	  	else if ($(this).val() == 'getresponse' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-getresponse-div').show();
	  	}

	  	else if ($(this).val() == 'campaignmonitor' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-div').show();
	  	}

	  	else if ($(this).val() == 'madmimi' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-madmimi-div').show();
	  	}

	  	else if ($(this).val() == 'infusionsoft' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-div').show();
	  	}

	  	else if ($(this).val() == 'mymail' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-mymail-div').show();
	  	}

	  	else if ($(this).val() == 'activecampaign' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-div').show();
	  	}

	  	else if ($(this).val() == 'feedburner' && $("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		  	$('.' + wps_ff_data.prefix_dash + 'news-letter-feedburner-div').show();
	  	}
	});

	$('.' + wps_ff_data.prefix_dash + 'news-letter-WordPress-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-getresponse-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-madmimi-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-mymail-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-div').hide();
	$('.' + wps_ff_data.prefix_dash + 'news-letter-feedburner-div').hide();

  	if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'WordPress' &&
			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		$('.' + wps_ff_data.prefix_dash + 'news-letter-WordPress-div').show();
	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'MailChimp' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
		$('.' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'aweber' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'getresponse' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-getresponse-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'campaignmonitor' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'madmimi' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-madmimi-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'infusionsoft' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'mymail' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-mymail-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'activecampaign' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-div').show();
  	}

  	else if ($('#' + wps_ff_data.prefix_dash + 'news-letter-type').val() == 'feedburner' &&
  			$("input[name='" + wps_ff_data.prefix_dash + "template']:checked").val() == 'newsletter') {
	  	$('.' + wps_ff_data.prefix_dash + 'news-letter-feedburner-div').show();
  	}

  	// Success Action

	$("." + wps_ff_data.prefix_dash + "news-letter-success-action").hide();
	$("." + wps_ff_data.prefix_dash + "news-letter-success-action-" + $("#" + wps_ff_data.prefix_dash + "news-letter-success-action").val()).show();

 	$("#" + wps_ff_data.prefix_dash + "news-letter-success-action").change(function() {
 		$("." + wps_ff_data.prefix_dash + "news-letter-success-action").hide();
 		$("." + wps_ff_data.prefix_dash + "news-letter-success-action-" + $(this).val()).show();

 	});

  	if (typeof(wps_ff_data.post_types) != "undefined" && wps_ff_data.post_types !== null) {

	  	// Trigger

		$('#' + wps_ff_data.prefix_dash + 'trigger-type').change(function(){
			for (var i = 0; i < wps_ff_data.post_types.length; i++) {
				$('#' + wps_ff_data.prefix_dash + 'trigger-div-' + wps_ff_data.post_types[i]).hide();
			}
			$('#' + wps_ff_data.prefix_dash + 'trigger-category-div').hide();
			$('#' + wps_ff_data.prefix_dash + 'trigger-tag-div').hide();


		  	if($(this).val() == 'category') {
			  	$('#' + wps_ff_data.prefix_dash + 'trigger-category-div').show();
		  	}else if($(this).val() == 'tag') {
			  	$('#' + wps_ff_data.prefix_dash + 'trigger-tag-div').show();
		  	}else {
			  	for (var i = 0; i < wps_ff_data.post_types.length; i++) {
			  		if($(this).val() == wps_ff_data.post_types[i]) {
				  		$('#' + wps_ff_data.prefix_dash + 'trigger-div-' + wps_ff_data.post_types[i]).show();
				  	}
				}
		  	}
		});

		for (var i = 0; i < wps_ff_data.post_types.length; i++) {
			$('#' + wps_ff_data.prefix_dash + 'trigger-div-' + wps_ff_data.post_types[i]).hide();
		}
		$('#' + wps_ff_data.prefix_dash + 'trigger-category-div').hide();
		$('#' + wps_ff_data.prefix_dash + 'trigger-tag-div').hide();

		if($('#' + wps_ff_data.prefix_dash + 'trigger-type').val() == 'category') {
		  	$('#' + wps_ff_data.prefix_dash + 'trigger-category-div').show();
	  	}else if($('#' + wps_ff_data.prefix_dash + 'trigger-type').val() == 'tag') {
		  	$('#' + wps_ff_data.prefix_dash + 'trigger-tag-div').show();
	  	}else {
		  	for (var i = 0; i < wps_ff_data.post_types.length; i++) {
		  		if($('#' + wps_ff_data.prefix_dash + 'trigger-type').val() == wps_ff_data.post_types[i]) {
			  		$('#' + wps_ff_data.prefix_dash + 'trigger-div-' + wps_ff_data.post_types[i]).show();
			  	}
			}
	  	}

	  	// Post Types

	  	for (var i = 0; i < wps_ff_data.post_types.length; i++) {
			$('#' + wps_ff_data.prefix_dash + 'trigger-all-' + wps_ff_data.post_types[i]).click(function() {
				if($(this).is(':checked')) {
					$('#' + wps_ff_data.prefix_dash + 'trigger-id-div-' + $(this).attr('data-post')).hide();
				}else{
					$('#' + wps_ff_data.prefix_dash + 'trigger-id-div-' + $(this).attr('data-post')).show();
				}
			});

			if($('#' + wps_ff_data.prefix_dash + 'trigger-all-' + wps_ff_data.post_types[i]).is(':checked')) {
				$('#' + wps_ff_data.prefix_dash + 'trigger-id-div-' + wps_ff_data.post_types[i]).hide();
			}
		}
  	}


	// Category

	$('#' + wps_ff_data.prefix_dash + 'trigger-category-all').click(function() {
		if($(this).is(':checked')) {
			$('#' + wps_ff_data.prefix_dash + 'trigger-category-id-div').hide();
		}else{
			$('#' + wps_ff_data.prefix_dash + 'trigger-category-id-div').show();
		}
	});

	if($('#' + wps_ff_data.prefix_dash + 'trigger-category-all').is(':checked')) {
		$('#' + wps_ff_data.prefix_dash + 'trigger-category-id-div').hide();
	}

	// Button Link

	$('#' + wps_ff_data.prefix_dash + 'display-button').change(function(){

		$('.' + wps_ff_data.prefix_dash + 'display-button').hide();

		if ($(this).prop('checked')) {
			$('.' + wps_ff_data.prefix_dash + 'display-button').show();
		}

	});

	$('.' + wps_ff_data.prefix_dash + 'display-button').hide();

	if ($('#' + wps_ff_data.prefix_dash + 'display-button').prop('checked')) {
		$('.' + wps_ff_data.prefix_dash + 'display-button').show();
	}

	// Google Fonts Toogle

  	$('#' + wps_ff_data.prefix_dash + 'google-font').hide();
  	$('#' + wps_ff_data.prefix_dash + 'font-family').hide();

	if ($('#' + wps_ff_data.prefix_dash + 'google-fonts').prop('checked')) {

		$('#' + wps_ff_data.prefix_dash + 'google-font').insertAfter($('#' + wps_ff_data.prefix_dash + 'font-family'));
		$('#' + wps_ff_data.prefix_dash + 'google-font').show();

	} else {

		$('#' + wps_ff_data.prefix_dash + 'font-family').insertAfter($('#' + wps_ff_data.prefix_dash + 'google-font'));
		$('#' + wps_ff_data.prefix_dash + 'font-family').show();
	}

	$('#' + wps_ff_data.prefix_dash + 'google-fonts').change(function(){

	  	$('#' + wps_ff_data.prefix_dash + 'google-font').hide();
	  	$('#' + wps_ff_data.prefix_dash + 'font-family').hide();

  		if ($(this).prop('checked')) {

  			$('#' + wps_ff_data.prefix_dash + 'google-font').insertAfter($('#' + wps_ff_data.prefix_dash + 'font-family'));
  			$('#' + wps_ff_data.prefix_dash + 'google-font').show();

  		} else {

  			$('#' + wps_ff_data.prefix_dash + 'font-family').insertAfter($('#' + wps_ff_data.prefix_dash + 'google-font'));
  			$('#' + wps_ff_data.prefix_dash + 'font-family').show();
  		}
  	});

	$('#' + wps_ff_data.prefix_dash + 'heading-google-font').hide();
	$('#' + wps_ff_data.prefix_dash + 'heading-font-family').hide();

	if ($('#' + wps_ff_data.prefix_dash + 'heading-google-fonts').prop('checked')) {

		$('#' + wps_ff_data.prefix_dash + 'heading-google-font').insertAfter($('#' + wps_ff_data.prefix_dash + 'heading-font-family'));
		$('#' + wps_ff_data.prefix_dash + 'heading-google-font').show();

	} else {

		$('#' + wps_ff_data.prefix_dash + 'heading-font-family').insertAfter($('#' + wps_ff_data.prefix_dash + 'heading-google-font'));
		$('#' + wps_ff_data.prefix_dash + 'heading-font-family').show();
	}


	$('#' + wps_ff_data.prefix_dash + 'heading-google-fonts').change(function(){

	  	$('#' + wps_ff_data.prefix_dash + 'heading-google-font').hide();
	  	$('#' + wps_ff_data.prefix_dash + 'heading-font-family').hide();

  		if ($(this).prop('checked')) {

  			$('#' + wps_ff_data.prefix_dash + 'heading-google-font').insertAfter($('#' + wps_ff_data.prefix_dash + 'heading-font-family'));
  			$('#' + wps_ff_data.prefix_dash + 'heading-google-font').show();

  		} else {

  			$('#' + wps_ff_data.prefix_dash + 'heading-font-family').insertAfter($('#' + wps_ff_data.prefix_dash + 'heading-google-font'));
  			$('#' + wps_ff_data.prefix_dash + 'heading-font-family').show();
  		}
  	});

  	// Get all MailChimp Lists

	$('#' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_ff_data.prefix_dash + 'MailChimp-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_ff_data.prefix_dash + 'MailChimp-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-MailChimp-list');

		var data = {
			'action': 'wps_ff_get_mailchimp_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-api-key').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'MailChimp-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-MailChimp-list').html(response);
		});
	});

	// Get Aweber Lists

	$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-connect').click(function(){
		$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').parent('div').parent('div').removeClass('hidden');
		$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').removeClass('hidden');
	});

	$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').keyup(function (){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_ff_data.prefix_dash + 'aweber-get-lists-spinner').length != 0) {
			return;
		}

		// Do nothing if the user did not input a code

		if ($('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').val() == '') {
			return;
		}

		$('#' + wps_ff_data.prefix_dash +'news-letter-aweber-list-id').html('');

		$('<i id="' + wps_ff_data.prefix_dash + 'aweber-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-aweber-list-id');

		var data = {
			'action': 'wps_ff_get_aweber_lists',
			'consumer_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-key').val(),
			'consumer_secret': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(),
			'access_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-key').val(),
			'access_secret': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-secret').val(),
			'code': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').val(),
			'firebar_id': getUrlParameter('firebar_id')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('#' + wps_ff_data.prefix_dash +'aweber-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-aweber-list-id').html(response.html);

			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-key').val(response.consumer_key);
			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(response.consumer_secret);
			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-key').val(response.access_key);
			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-secret').val(response.access_secret);

			if (response.consumer_key != '') {
				$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').addClass('hidden');
			}

		});
	});

	// Get all Get Response Lists

	$('#' + wps_ff_data.prefix_dash + 'news-letter-getresponse-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_ff_data.prefix_dash + 'getresponse-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_ff_data.prefix_dash + 'getresponse-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-getresponse-campaign');

		var data = {
			'action': 'wps_ff_get_getresponse_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-getresponse-api-key').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'getresponse-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-getresponse-campaign').html(response);
		});
	});

	// Get all Campaign Monitor Clients and Lists

	$('#' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('.' + wps_ff_data.prefix_dash + 'campaignmonitor-get-lists-spinner').length != 0) {
			return;
		}

		$('<i class="' + wps_ff_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-list');
		$('<i class="' + wps_ff_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-client');

		var data = {
			'action': 'wps_ff_get_campaignmonitor_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-api-key').val(),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('.' + wps_ff_data.prefix_dash +'campaignmonitor-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-client').html(response.clients);
			$('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-list').html(response.lists);

		});
	});

	// Update lists for Campaign Monitor

	$('#' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-client').change(function(){

		// Do nothing if we are already retrieve the lists

		if ($('.' + wps_ff_data.prefix_dash + 'campaignmonitor-get-lists-spinner').length != 0) {
			return;
		}

		$('<i class="' + wps_ff_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-list');

		var data = {
			'action': 'wps_ff_update_campaignmonitor_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-api-key').val(),
			'client_id': $(this).val(),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('.' + wps_ff_data.prefix_dash +'campaignmonitor-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-list').html(response);
		});
	});

	// Get all Mad Mimi Lists

	$('#' + wps_ff_data.prefix_dash + 'news-letter-madmimi-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_ff_data.prefix_dash + 'madmimi-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_ff_data.prefix_dash + 'madmimi-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-madmimi-list');

		var data = {
			'action': 'wps_ff_get_madmimi_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-madmimi-api-key').val(),
			'username': $('#' + wps_ff_data.prefix_dash + 'news-letter-madmimi-username').val(),
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-madmimi-list').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'madmimi-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-madmimi-list').html(response);
		});
	});

	// Get all Infusionsoft Lists

	$('#' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_ff_data.prefix_dash + 'infusionsoft-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_ff_data.prefix_dash + 'infusionsoft-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-list');

		var data = {
			'action': 'wps_ff_get_infusionsoft_lists',
			'app_id': $('#' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-app-id').val(),
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-api-key').val(),
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-infusionsoft-list').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'infusionsoft-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-infusionsoft-list').html(response);
		});
	});

	// Get all MyMail Lists

	$('#' + wps_ff_data.prefix_dash + 'news-letter-mymail-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_ff_data.prefix_dash + 'mymail-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_ff_data.prefix_dash + 'mymail-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash + 'news-letter-mymail-list');

		var data = {
			'action': 'wps_ff_get_mymail_lists',
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-mymail-list').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'mymail-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-mymail-list').html(response);
		});
	});

	// Get all Active Campaign Lists

	$('#' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_ff_data.prefix_dash + 'activecampaign-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_ff_data.prefix_dash + 'activecampaign-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-list');

		var data = {
			'action': 'wps_ff_get_activecampaign_lists',
			'app_url': $('#' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-app-url').val(),
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-api-key').val(),
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-activecampaign-list').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'activecampaign-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-activecampaign-list').html(response);
		});
	});

  	setTimeout(function() {

	  	// MailChimp

		$('<i id="' + wps_ff_data.prefix_dash + 'MailChimp-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-MailChimp-list');

		var data = {
			'action': 'wps_ff_get_mailchimp_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-api-key').val(),
			'list': $('#' + wps_ff_data.prefix_dash + 'news-letter-MailChimp-list').attr('data-list'),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'MailChimp-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-MailChimp-list').html(response);
		});

		// Aweber

		$('#' + wps_ff_data.prefix_dash +'news-letter-aweber-list-id').html('');

		$('<i id="' + wps_ff_data.prefix_dash + 'aweber-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-aweber-list-id');

		var data = {
			'action': 'wps_ff_get_aweber_lists',
			'consumer_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-key').val(),
			'consumer_secret': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(),
			'access_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-key').val(),
			'access_secret': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-secret').val(),
			'code': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').val(),
			'flyout_fire_id': getUrlParameter('flyout_fire_id'),
			'list': $('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-list-id').attr('data-list'),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('#' + wps_ff_data.prefix_dash +'aweber-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-aweber-list-id').html(response.html);

			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-key').val(response.consumer_key);
			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(response.consumer_secret);
			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-key').val(response.access_key);
			$('#' + wps_ff_data.prefix_dash + 'news-letter-aweber-access-secret').val(response.access_secret);

			if (response.consumer_key != '') {
				$('.' + wps_ff_data.prefix_dash + 'news-letter-aweber-code').addClass('hidden');
			}

		});

		// Get Response

		$('<i id="' + wps_ff_data.prefix_dash + 'getresponse-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-getresponse-campaign');

		var data = {
			'action': 'wps_ff_get_getresponse_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-getresponse-api-key').val(),
			'campaign': $('#' + wps_ff_data.prefix_dash + 'news-letter-getresponse-campaign').attr('data-campaign')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'getresponse-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-getresponse-campaign').html(response);
		});

		// Campaign Monitor

		$('<i class="' + wps_ff_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>')
				.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-list');
		$('<i class="' + wps_ff_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-client');

		var data = {
			'action': 'wps_ff_get_campaignmonitor_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-api-key').val(),
			'client': $('#' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-client').attr('data-client'),
			'list': $('#' + wps_ff_data.prefix_dash + 'news-letter-campaignmonitor-list').attr('data-list'),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('.' + wps_ff_data.prefix_dash +'campaignmonitor-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-client').html(response.clients);
			$('#' + wps_ff_data.prefix_dash +'news-letter-campaignmonitor-list').html(response.lists);

		});

		// Mad Mimi

		$('<i id="' + wps_ff_data.prefix_dash + 'madmimi-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-madmimi-list');

		var data = {
			'action': 'wps_ff_get_madmimi_lists',
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-madmimi-api-key').val(),
			'username': $('#' + wps_ff_data.prefix_dash + 'news-letter-madmimi-username').val(),
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-madmimi-list').attr('data-list')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'madmimi-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-madmimi-list').html(response);
		});

		// Infusionsoft

		$('<i id="' + wps_ff_data.prefix_dash + 'infusionsoft-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-infusionsoft-list');

		var data = {
			'action': 'wps_ff_get_infusionsoft_lists',
			'app_id': $('#' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-app-id').val(),
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-infusionsoft-api-key').val(),
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-infusionsoft-list').attr('data-list')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'infusionsoft-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-infusionsoft-list').html(response);
		});

		// Active Campaign

		$('<i id="' + wps_ff_data.prefix_dash + 'activecampaign-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-activecampaign-list');

		var data = {
			'action': 'wps_ff_get_activecampaign_lists',
			'app_url': $('#' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-app-url').val(),
			'api_key': $('#' + wps_ff_data.prefix_dash + 'news-letter-activecampaign-api-key').val(),
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-activecampaign-list').attr('data-list')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'activecampaign-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-activecampaign-list').html(response);
		});

		// MyMail

		$('<i id="' + wps_ff_data.prefix_dash + 'mymail-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_ff_data.prefix_dash +'news-letter-mymail-list');

		var data = {
			'action': 'wps_ff_get_mymail_lists',
			'list': $('#' + wps_ff_data.prefix_dash +'news-letter-mymail-list').attr('data-list')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_ff_data.ajaxurl, data, function(response) {
			$('#' + wps_ff_data.prefix_dash +'mymail-get-lists-spinner').remove();
			$('#' + wps_ff_data.prefix_dash +'news-letter-mymail-list').html(response);
		});

	  	// Create an easy interface for selecting categories

		$.post(wps_ff_data.ajaxurl, {'action': 'wps_ff_get_categories'}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var tag_options = [];

		  	$.each(response, function( index, value ) {
			  	tag_options.push( {id: value.term_id, name: value.name} );
			});

		  	$('#' + wps_ff_data.prefix_dash + 'trigger-category-id').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});
		});

	   	// Create an easy interface for selecting tags

		$.post(wps_ff_data.ajaxurl, {'action': 'wps_ff_get_tags'}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var tag_options = [];

		  	$.each(response, function( index, value ) {
			  	tag_options.push( {id: value.term_id, name: value.name} );
			});

		  	$('#' + wps_ff_data.prefix_dash + 'trigger-tag-id').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});

		  	$('#' + wps_ff_data.prefix_dash + 'recent-posts-tag').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});
		});

		if ($('#' + wps_ff_data.prefix_dash + 'trigger-type').val() != 'site' ||
			$('#' + wps_ff_data.prefix_dash + 'trigger-type').val() != 'category' ||
			$('#' + wps_ff_data.prefix_dash + 'trigger-type').val() != 'tag' ||
			$('#' + wps_ff_data.prefix_dash + 'trigger-type').val() != 'archive') {

			$.post(wps_ff_data.ajaxurl, {'action': 'wps_ff_get_posts', 'post_type': $('#' + wps_ff_data.prefix_dash + 'trigger-type').val()}, function(response) {

				response = $.parseJSON(response);

				// Create an easy interface for selecting tags

			  	var post_options = [];

			  	$.each(response, function( index, value ) {
				  	var post_title = 'No title';

				  	if ( value.post_title != '' ) {
					  	post_title = value.post_title;
				  	}

				  	post_options.push({id: value.ID, name: post_title});
				});

				$('.' + wps_ff_data.prefix_dash + 'trigger-id-' + $('#' + wps_ff_data.prefix_dash + 'trigger-type').val()).selectize({
				  	plugins: ['remove_button'],
				  	valueField: 'id',
					labelField: 'name',
					searchField: 'name',
				  	options: post_options,
			  	});
			});

		}

	} ,1);

	// Populate all Exclude post selectize on load

	$('#' + wps_ff_data.prefix_dash + 'trigger-type option').each(function() {

		$.post(wps_ff_data.ajaxurl, {'action': 'wps_ff_get_posts', 'post_type': $(this).val()}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var post_options = [];
		  	var post_type = '';

		  	$.each(response, function( index, value ) {
			  	var post_title = 'No title';

			  	if ( value.post_title != '' ) {
				  	post_title = value.post_title;
			  	}

			  	post_options.push({id: value.ID, name: post_title});
			  	post_type = value.post_type;
			});

			// Exclude posts

			$('.' + wps_ff_data.prefix_dash + 'trigger-exclude-' + post_type).selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: post_options,
		  	});
		});
	});

	$('#' + wps_ff_data.prefix_dash + 'trigger-type').change(function() {

		if ($(this).val() != 'site' || $(this).val() != 'category' || $(this).val() != 'tag' || $(this).val() != 'archive') {

			$.post(wps_ff_data.ajaxurl, {'action': 'wps_ff_get_posts', 'post_type': $(this).val()}, function(response) {

				response = $.parseJSON(response);

				// Create an easy interface for selecting tags

			  	var post_options = [];

			  	$.each(response, function( index, value ) {
				  	var post_title = 'No title';

				  	if ( value.post_title != '' ) {
					  	post_title = value.post_title;
				  	}

				  	post_options.push({id: value.ID, name: post_title});
				});

				if (!$('.' + wps_ff_data.prefix_dash + 'trigger-id-' + $('#' + wps_ff_data.prefix_dash + 'trigger-type').val()).hasClass('selectized')) {
					$('.' + wps_ff_data.prefix_dash + 'trigger-id-' + $('#' + wps_ff_data.prefix_dash + 'trigger-type').val()).selectize({
					  	plugins: ['remove_button'],
					  	valueField: 'id',
						labelField: 'name',
						searchField: 'name',
					  	options: post_options,
				  	});
				}
			});
		}
	});

	// Add selectize to the Referrer Domains

	var referrer_options = [
		{id: 't.co'},
		{id: 'www.facebook.com'},
		{id: 'plus.url.google.com'},
		{id: 'www.linkedin.com'},
	];

	var temp_referrer_options = $('#' + wps_ff_data.prefix_dash + 'trigger-args-referrer').attr('data-urls').split(',');

	$.each(temp_referrer_options, function( index, value ) {
	  	referrer_options.push({id: value});
	});

	$('#' + wps_ff_data.prefix_dash + 'trigger-args-referrer').selectize({
		plugins: ['remove_button'],
		create: true,
		valueField: 'id',
		labelField: 'id',
		searchField: 'id',
		options: referrer_options,
	});

	function getUrlParameter(sParam) {
	    var sPageURL = window.location.search.substring(1);
	    var sURLVariables = sPageURL.split('&');
	    for (var i = 0; i < sURLVariables.length; i++)
	    {
	        var sParameterName = sURLVariables[i].split('=');
	        if (sParameterName[0] == sParam)
	        {
	            return sParameterName[1];
	        }
	    }
	}

});