/**
 *
 * Created by Kyle Benk
 *
 * kjbenk@gmail.com
 *
 */

jQuery(document).ready(function($) {

	var flyout = false;
	var cus_flyout = false;
	var display_flyout = false;

	// Show flyout fire

	if (typeof(wps_ff_data) != "undefined" && wps_ff_data !== null) {

		var location = wps_ff_data.location.toLowerCase();
		var contanier = '.' + wps_ff_data.prefix_dash + 'container-' + location;
		var link_img = '.' + wps_ff_data.prefix_dash + 'link img';

		// Add span tags to all text elements in Twitter Feed

		if ($('.' + wps_ff_data.prefix_dash + 'twitter-feed li').length != 0) {
			$.each($('.' + wps_ff_data.prefix_dash + 'twitter-feed li'), function(key, value) {
				var textnodes = wpsite_ff_getTextNodesIn($(this)[0]);

				for(var i=0; i < textnodes.length; i++){
				    if($(textnodes[i]).parent().is(this)){
				        $(textnodes[i]).wrap("<span class='" + wps_ff_data.prefix_dash + "twitter-feed-text'>");
				    }
				}

			});
		}

		// Add Style

		wpsite_fire_flyout_add_style(location);
		wpsite_flyout_fire_setup_location(location);

		// Preview

	    if (wps_ff_data.preview) {

	    	display_flyout_fire(location, 'preview');
	    }

	    // Timer

	    else if (wps_ff_data.trigger_type == 'timer') {
			$(function() {

				var flyout_fire_timer = setInterval(function() {

			    	display_flyout_fire(location, wps_ff_data.trigger_type);

		            clearInterval(flyout_fire_timer);
		        }, wps_ff_data.timer);

		    });
	    }

	    // Exit Intent

	    else if (wps_ff_data.trigger_type == 'exit') {

		    var _html = document.documentElement;

		    _html.addEventListener('mouseleave', function(e) {

		    	display_flyout_fire(location, wps_ff_data.trigger_type);
		    });

			_html.addEventListener('keydown', function(e) {

				if (!e.metaKey || e.keyCode !== 76) {
					return;
				}

		    	display_flyout_fire(location, wps_ff_data.trigger_type);
			});
	    }

	    // Scroll

	    else if (wps_ff_data.trigger_type == 'scroll') {

		    $(window).scroll(function (event) {
			    var height = $(document).height();
				var scroll = $(window).scrollTop() + $(window).height();

				if (parseInt((scroll / height) * 100) >= wps_ff_data.scroll) {

			    	display_flyout_fire(location, wps_ff_data.trigger_type);

				}
			});
	    }

	    // Custom Button

	    else if (wps_ff_data.trigger_type == 'button') {

		    // Custom Button

		    $('.' + wps_ff_data.prefix_dash + 'custom-button-' + $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')).click(function(event){
				display_flyout_fire(location, 'button');
			});

	    }

	    // Close Button

	    if ( $('.' + wps_ff_data.prefix_dash + 'close-button').length !== 0) {

			$('.' + wps_ff_data.prefix_dash + 'close-button').click(function(){

				if ( wps_ff_data.dont_show_again ) {
					var data = {
						'action': 'nnr_ff_set_close_cookie',
						'flyout_fire_id': $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')
					};
					// We can also pass the url value separately from ajaxurl for front end AJAX implementations
					$.post(wps_ff_data.ajaxurl, data, function(response) {
						console.log(response);
					});
				}

				wpsite_flyout_fire_hide(location);

			});

		}

		// Hide and Show

		else {

		 	// Toogle the Flyout Fire

			$('.' + wps_ff_data.prefix_dash + 'show').click(function(){
				wpsite_flyout_fire_show(location, false);
			});

			// Desktop Version

			$('body').on('click', function(event){

				var container = $('.' + wps_ff_data.prefix_dash + 'container');

				// Check if a Flyout Fire is currently being displayed
				// Check if button was clicked from Custom button

				if (wps_ff_data.trigger_type == 'button') {
					if (cus_flyout && display_flyout &&
						!$('.' + wps_ff_data.prefix_dash + 'custom-button-' + $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')).is(event.target) &&
						!$('.' + wps_ff_data.prefix_dash + 'show').is(event.target) &&
						!container.is(event.target) && container.has(event.target).length === 0) {

						wpsite_flyout_fire_hide(location);
					}
				} else {
					if (flyout && display_flyout &&
						!$('.' + wps_ff_data.prefix_dash + 'custom-button-' + $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')).is(event.target) &&
						!$('.' + wps_ff_data.prefix_dash + 'show').is(event.target) &&
						!container.is(event.target) && container.has(event.target).length === 0) {

						wpsite_flyout_fire_hide(location);
					}
				}

			});

			// Mobile Verison

			document.addEventListener('touchstart', function(e) {
			    var container = $('.' + wps_ff_data.prefix_dash + 'container');

				// Check if a Flyout Fire is currently being displayed
				// Check if button was clicked from Custom button

				if (wps_ff_data.trigger_type == 'button') {
					if (cus_flyout && display_flyout &&
						!$('.' + wps_ff_data.prefix_dash + 'custom-button-' + $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')).is(event.target) &&
						!$('.' + wps_ff_data.prefix_dash + 'show').is(event.target) &&
						!container.is(event.target) && container.has(event.target).length === 0) {

						wpsite_flyout_fire_hide(location);
					}
				} else {
					if (flyout && display_flyout &&
						!$('.' + wps_ff_data.prefix_dash + 'custom-button-' + $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')).is(event.target) &&
						!$('.' + wps_ff_data.prefix_dash + 'show').is(event.target) &&
						!container.is(event.target) && container.has(event.target).length === 0) {

						wpsite_flyout_fire_hide(location);
					}
				}


			}, false);

		}

	    // Email Submission

	    if ($('#' + wps_ff_data.prefix_dash + 'newsletter-type').length != 0) {

		    $('#' + wps_ff_data.prefix_dash + 'newsletter').submit(function(event){

			    $('.' + wps_ff_data.prefix_dash + 'message').html();

			    if ($('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'WordPress' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'MailChimp' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'aweber' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'getresponse' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'campaignmonitor' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'madmimi' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'infusionsoft' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'mymail' ||
			    	$('#' + wps_ff_data.prefix_dash + 'newsletter-type').html() == 'activecampaign') {

				    $('#' + wps_ff_data.prefix_dash + 'submit').append('<i style="margin-left: 10px;" class="' + wps_ff_data.prefix_dash + 'submit-spinner fa fa-spinner fa-spin"></i>');

				    event.preventDefault();

					var data = {
						'action': 'wps_ff_add_email',
						'flyout_fire_id': $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id'),
						'type': $('#' + wps_ff_data.prefix_dash + 'newsletter-type').html(),
						'email': $('#' + wps_ff_data.prefix_dash + 'email').val(),
						'first_name': $('#' + wps_ff_data.prefix_dash + 'first-name').val(),
						'last_name': $('#' + wps_ff_data.prefix_dash + 'last-name').val(),
					};

					// We can also pass the url value separately from ajaxurl for front end AJAX implementations
					jQuery.post(wps_ff_data.ajaxurl, data, function(response) {
						response = jQuery.parseJSON(response);
						console.log(response.conversion);

						$('.' + wps_ff_data.prefix_dash + 'submit-spinner').remove();

						// Dismiss flyout on a successful entry

						if (response.status == 'check') {

							if (wps_ff_data.success_action == 'message') {

								$('.' + wps_ff_data.prefix_dash + 'message').html('<i class="fa fa-' + response.status + '"></i> ' + response.message);
								setTimeout(function() {

									wpsite_flyout_fire_hide(wps_ff_data.location.toLowerCase());

								}, 3000);

							} else if (wps_ff_data.success_action == 'redirect') {

								var win = window.open(wps_ff_data.success_url, '_self');
								win.focus();
							}

						} else {
							$('.' + wps_ff_data.prefix_dash + 'message').html('<i class="fa fa-' + response.status + '"></i> ' + response.message);
						}
					});

			    }
			});

	    }

	    // Contact Us form

	    $('#' + wps_ff_data.prefix_dash + 'contact-us').submit(function(event){


			$('#' + wps_ff_data.prefix_dash + 'submit').append('<i style="margin-left: 10px;" class="' + wps_ff_data.prefix_dash + 'submit-spinner fa fa-spinner fa-spin"></i>');

		    event.preventDefault();

			var data = {
				'action': 'wps_ff_send_email',
				'flyout_fire_id': $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id'),
				'send': $('#' + wps_ff_data.prefix_dash + 'send').val(),
				'email': $('#' + wps_ff_data.prefix_dash + 'email').val(),
				'subject': $('#' + wps_ff_data.prefix_dash + 'subject').val(),
				'message': $('#' + wps_ff_data.prefix_dash + 'message').val(),
			};

			// We can also pass the url value separately from ajaxurl for front end AJAX implementations
			jQuery.post(wps_ff_data.ajaxurl, data, function(response) {

				response = jQuery.parseJSON(response);
				console.log(response.conversion);

				$('.' + wps_ff_data.prefix_dash + 'submit-spinner').remove();

				// Dismiss flyout on a successful entry

				if (response.status == 'check') {

					if (wps_ff_data.success_action == 'message') {

						$('.' + wps_ff_data.prefix_dash + 'message').html('<i class="fa fa-' + response.status + '"></i> ' + response.message);
						setTimeout(function() {

							wpsite_flyout_fire_hide(wps_ff_data.location.toLowerCase());

						}, 3000);

					} else if (wps_ff_data.success_action == 'redirect') {

						var win = window.open(wps_ff_data.success_url, '_self');
						win.focus();
					}

				} else {
					$('.' + wps_ff_data.prefix_dash + 'message').html('<i class="fa fa-' + response.status + '"></i> ' + response.message);
				}

			});
		});

	    // Scroller Flyout Fires

	    if ($('.' + wps_ff_data.prefix_dash + 'scroller').length != 0) {

		    // Tweets

			$('.' + wps_ff_data.prefix_dash + 'scroller').newsTicker();
		}

		// Track links being clicked

		$('.' + wps_ff_data.prefix_dash + 'container').click(function(event){

			// Link was clicked

			if ($(event.target).closest('a').length){

				var data = {
					'action': 'wps_ff_record_click',
					'flyout_fire_id': $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')
				};
				// We can also pass the url value separately from ajaxurl for front end AJAX implementations
				$.post(wps_ff_data.ajaxurl, data, function(response) {
					console.log(response);
				});

			}
		});
	}

	/**
	 * Displayes either the fire flyout or the stub
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function display_flyout_fire(location, type) {

		// Custom Button

		if (type == 'button') {

			if (!cus_flyout) {

				// Record Impression

				var data = {
					'action': 'wps_ff_record_impression',
					'flyout_fire_id': $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')
				};
				// We can also pass the url value separately from ajaxurl for front end AJAX implementations
				$.post(wps_ff_data.ajaxurl, data, function(response) {
					console.log(response);
				});

				cus_flyout = true;

			}

			$('.' + wps_ff_data.prefix_dash + 'stub').show();
	      	$('.' + wps_ff_data.prefix_dash + 'container').show();

			wpsite_flyout_fire_show(location);

		} else if (!flyout) {

			flyout = true;

			// Record Impression

			var data = {
				'action': 'wps_ff_record_impression',
				'flyout_fire_id': $('#' + wps_ff_data.prefix_dash + 'flyout-fire-id').attr('data-flyout-fire-id')
			};
			// We can also pass the url value separately from ajaxurl for front end AJAX implementations
			$.post(wps_ff_data.ajaxurl, data, function(response) {
				console.log(response);
			});

			$('.' + wps_ff_data.prefix_dash + 'stub').show();
	      	$('.' + wps_ff_data.prefix_dash + 'container').show();

			wpsite_flyout_fire_show(location);
		}

		return false;
	}

	/**
	 * Show flyout fire
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_flyout_fire_show(location) {

	    if (wps_ff_data.animation == 'yes') {

	  		wpsite_flyout_fire_show_animation(location);

      	} else {

      		$('.' + wps_ff_data.prefix_dash + 'stub').hide();
	      	$('.' + wps_ff_data.prefix_dash + 'container').show();

      	}

      	display_flyout = true;
	}

	/**
	 * Hide the flyout fire
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_flyout_fire_hide(location) {

		if (wps_ff_data.animation == 'yes') {

			wpsite_flyout_fire_hide_animation(location);

		} else {

			$('.' + wps_ff_data.prefix_dash + 'container').hide();

			if ( !wps_ff_data.close_button ) {
				$('.' + wps_ff_data.prefix_dash + 'stub').show();
			}

		}

		display_flyout = false;
	}

	/**
	 * Setup the Flyout Fire location
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_flyout_fire_setup_location(location) {

		var container = '.' + wps_ff_data.prefix_dash + 'container';
		var stub = '.' + wps_ff_data.prefix_dash + 'stub';

		var container_width = $(container).outerWidth() + 20;
		var container_height = $(container).outerHeight() + 20;
		var stub_width = $(stub).outerWidth();
		var stub_height = $(stub).outerHeight();

		switch (location) {

			case '1':

				if (wps_ff_data.slide_direction == 'up') {
					$(stub).css('top', '-' + stub_height + 'px');
					$(container).css('top', '-' + container_height + 'px');
				} else {
					$(stub).css('left', '-' + stub_width + 'px');
					$(container).css('left', '-' + container_width + 'px');
				}

				break;

			case '2':
				$(stub).css('top', '-' + stub_height + 'px');
				$(container).css('top', '-' + container_height + 'px');

				break;

			case '3':

				if (wps_ff_data.slide_direction == 'up') {
					$(stub).css('top', '-' + stub_height + 'px');
					$(container).css('top', '-' + container_height + 'px');
				} else {
					$(stub).css('right', '-' + stub_width + 'px');
					$(container).css('right', '-' + container_width + 'px');
				}

				break;

			case '4':

				$(stub).css('left', '-' + stub_width + 'px');
				$(container).css('left', '-' + container_width + 'px');

				break;

			case '6':

				$(stub).css('right', '-' + stub_width + 'px');
				$(container).css('right', '-' + container_width + 'px');

				break;

			case '7':

				if (wps_ff_data.slide_direction == 'down') {
					$(stub).css('bottom', '-' + stub_height + 'px');
					$(container).css('bottom', '-' + container_height + 'px');
				} else {
					$(stub).css('left', '-' + stub_width + 'px');
					$(container).css('left', '-' + container_width + 'px');
				}

				break;

			case '8':

				$(stub).css('bottom', '-' + stub_height + 'px');
				$(container).css('bottom', '-' + container_height + 'px');

				break;

			case '9':

				if (wps_ff_data.slide_direction == 'down') {
					$(stub).css('bottom', '-' + stub_height + 'px');
					$(container).css('bottom', '-' + container_height + 'px');
				} else {
					$(stub).css('right', '-' + stub_width + 'px');
					$(container).css('right', '-' + container_width + 'px');
				}

				break;
		}
	}

	/**
	 * Show firebar based on location and what slide direction
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_flyout_fire_show_animation(location) {

		var width = $('.' + wps_ff_data.prefix_dash + 'stub').outerWidth();
		var height = $('.' + wps_ff_data.prefix_dash + 'stub').outerHeight();

		var stub_animation, container_animation;

		switch (location) {

			case '1':

				if (wps_ff_data.slide_direction == 'up') {
					stub_animation  = {top: '-=' + height + 'px'};
					container_animation = {top: '0px'};
				} else {
					stub_animation  = {left: '-=' + width + 'px'};
					container_animation = {left: '0px'};
				}

				break;

			case '2':
				stub_animation  = {top: '-=' + height + 'px'};
				container_animation = {top: '0px'};

				break;

			case '3':

				if (wps_ff_data.slide_direction == 'up') {
					stub_animation  = {top: '-=' + height + 'px'};
					container_animation = {top: '0px'};
				} else {
					stub_animation  = {right: '-=' + width + 'px'};
					container_animation = {right: '0px'};
				}

				break;

			case '4':

				stub_animation  = {left: '-=' + width + 'px'};
				container_animation = {left: '0px'};

				break;

			case '6':

				stub_animation  = {right: '-=' + width + 'px'};
				container_animation = {right: '0px'};

				break;

			case '7':

				if (wps_ff_data.slide_direction == 'down') {
					stub_animation  = {bottom: '-=' + height + 'px'};
					container_animation = {bottom: '0px'};
				} else {
					stub_animation  = {left: '-=' + width + 'px'};
					container_animation = {left: '0px'};
				}

				break;

			case '8':

				stub_animation  = {bottom: '-=' + height + 'px'};
				container_animation = {bottom: '0px'};

				break;

			case '9':

				if (wps_ff_data.slide_direction == 'down') {
					stub_animation  = {bottom: '-=' + height + 'px'};
					container_animation = {bottom: '0px'};
				} else {
					stub_animation  = {right: '-=' + width + 'px'};
					container_animation = {right: '0px'};
				}

				break;
		}

  		if (wps_ff_data.full == 'yes' && wps_ff_data.push_pull == 'yes') {

	  		$('body').css('position', 'relative');

			if (wps_ff_data.location == '1' || wps_ff_data.location == '2' || wps_ff_data.location == '3') {
				$('body').animate({top: '+=' + ($('.' + wps_ff_data.prefix_dash + 'container').outerHeight() + 20) + 'px'});
			} else if (wps_ff_data.location == '4') {
				$('body').animate({left: '+=' + ($('.' + wps_ff_data.prefix_dash + 'container').outerWidth() + 20) + 'px'});
			} else if (wps_ff_data.location == '6') {
				$('body').animate({right: '+=' + ($('.' + wps_ff_data.prefix_dash + 'container').outerWidth() + 20) + 'px'});
			} else if (wps_ff_data.location == '7' || wps_ff_data.location == '8' || wps_ff_data.location == '9') {
				$('body').animate({bottom: '+=' + ($('.' + wps_ff_data.prefix_dash + 'container').outerHeight() + 20) + 'px'});
			}
		}

		if ( $('.' + wps_ff_data.prefix_dash + 'stub').length == 0 ) {
			$('.' + wps_ff_data.prefix_dash + 'container').animate(container_animation);
		}

		$('.' + wps_ff_data.prefix_dash + 'stub').animate(stub_animation, 500, function() {
			$('.' + wps_ff_data.prefix_dash + 'container').animate(container_animation);
  		});

	}

	/**
	 * Hide flyout based on location and what slide direction
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_flyout_fire_hide_animation(location) {

		var width = ($('.' + wps_ff_data.prefix_dash + 'container').outerWidth() + 20);
		var height = ($('.' + wps_ff_data.prefix_dash + 'container').outerHeight() + 20);

		var stub_animation, container_animation;

		switch (location) {

			case '1':

				if (wps_ff_data.slide_direction == 'up') {
					stub_animation  = {top: '0px'};
					container_animation = {top: '-=' + height + 'px'};
				} else {
					stub_animation  = {left: '0px'};
					container_animation = {left: '-=' + width + 'px'};
				}

				break;

			case '2':

				stub_animation  = {top: '0px'};
				container_animation = {top: '-=' + height + 'px'};

				break;

			case '3':

				if (wps_ff_data.slide_direction == 'up') {
					stub_animation  = {top: '0px'};
					container_animation = {top: '-=' + height + 'px'};
				} else {
					stub_animation  = {right: '0px'};
					container_animation = {right: '-=' + width + 'px'};
				}

				break;

			case '4':

				stub_animation  = {left: '0px'};
				container_animation = {left: '-=' + width + 'px'};

				break;

			case '6':

				stub_animation  = {right: '0px'};
				container_animation = {right: '-=' + width + 'px'};

				break;

			case '7':

				if (wps_ff_data.slide_direction == 'down') {
					stub_animation  = {bottom: '0px'};
					container_animation = {bottom: '-=' + height + 'px'};
				} else {
					stub_animation  = {left: '0px'};
					container_animation = {left: '-=' + width + 'px'};
				}

				break;

			case '8':

				stub_animation  = {bottom: '0px'};
				container_animation = {bottom: '-=' + height + 'px'};

				break;

			case '9':

				if (wps_ff_data.slide_direction == 'down') {
					stub_animation  = {bottom: '0px'};
					container_animation = {bottom: '-=' + height + 'px'};
				} else {
					stub_animation  = {right: '0px'};
					container_animation = {right: '-=' + width + 'px'};
				}

				break;
		}

		if (wps_ff_data.full == 'yes' && wps_ff_data.push_pull == 'yes') {

			if (wps_ff_data.location == '1' || wps_ff_data.location == '2' || wps_ff_data.location == '3') {
				$('body').animate({
					top: '-=' + height + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			} else if (wps_ff_data.location == '4') {
				$('body').animate({
					left: '-=' + width + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			} else if (wps_ff_data.location == '6') {
				$('body').animate({
					right: '-=' + width + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			} else if (wps_ff_data.location == '7' || wps_ff_data.location == '8' || wps_ff_data.location == '9') {
				$('body').animate({
					bottom: '-=' + height + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			}
		}

		$('.' + wps_ff_data.prefix_dash + 'container').animate(container_animation, 500, function() {

			console.log(wps_ff_data);

			if ( !wps_ff_data.close_button ) {
				$('.' + wps_ff_data.prefix_dash + 'stub').animate(stub_animation);
			}

		});

	}

	/**
	 * Adds style to the flyout fire
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function wpsite_fire_flyout_add_style(location) {

		var container = '.' + wps_ff_data.prefix_dash + 'container';
		var icon = '.' + wps_ff_data.prefix_dash + 'icon';
		var show = '.' + wps_ff_data.prefix_dash + 'show';
		var stub = '.' + wps_ff_data.prefix_dash + 'stub';
		var close = '.' + wps_ff_data.prefix_dash + 'close';
		var text = '.' + wps_ff_data.prefix_dash + 'text';
		var link = '.' + wps_ff_data.prefix_dash + 'link';
		var link_button = '.' + wps_ff_data.prefix_dash + 'link-button';
		var nl_button = '.' + wps_ff_data.prefix_dash + 'newsletter-button';
		var cu_button = '.' + wps_ff_data.prefix_dash + 'contact-us-button';

		// Move the Flyout Fire if user resizes window

		if ( wps_ff_data.full != 'yes' && (location == '4' || location == '6') ) {
			$(window).resize(function(){

			    $(container).css({
			        position:'fixed',
			        top: ($(window).height() - $(container).outerHeight())/2
			    });

			    $(stub).css({
			        position:'fixed',
			        top: ($(window).height() - $(stub).outerHeight())/2
			    });

			});

			// To initially run the function:
			$(window).resize();
		}

		// Include the Goolge Font files

		if (wps_ff_data.heading_google_fonts) {
			wpsite_fire_flyout_add_google_font(wps_ff_data.heading_font_family);
		}

		if (wps_ff_data.google_fonts) {
			wpsite_fire_flyout_add_google_font(wps_ff_data.font_family);
		}

		// Font Style

		// Small

		if (wps_ff_data.font_size == 14) {
			$(icon).css('font-size', parseInt(wps_ff_data.font_size) + 10 + 'px');
		}

		// Medium

		else if (wps_ff_data.font_size == 18) {
			$(icon).css('font-size', parseInt(wps_ff_data.font_size) + 12 + 'px');
		}

		// Large

		else if (wps_ff_data.font_size == 22) {
			$(icon).css('font-size', parseInt(wps_ff_data.font_size) + 14 + 'px');
		}

		// Auto

		else {
			$('.' + wps_ff_data.prefix_dash + 'scroller').css('height', '22px');
			$(icon).css('font-size', parseInt(wps_ff_data.font_size) + 12 + 'px');
		}

		// Add font styling

		if (wps_ff_data.font_size != 'auto') {
			$(container).find('*')
				.not(show)
				.not(close)
				.not(icon)
				.not('input')
				.not('button')
				.not('textarea')
				.not('i')
				.not('.' + wps_ff_data.prefix_dash + 'footer p')
				.not('.' + wps_ff_data.prefix_dash + 'powered-by p')
				.not('.' + wps_ff_data.prefix_dash + 'powered-by p a')
				.not('.' + wps_ff_data.prefix_dash + 'heading')
				.not('.' + wps_ff_data.prefix_dash + 'message')
				.css('font-size', wps_ff_data.font_size + 'px');
		}

		$(container).find('*')
			.not(show)
			.not(close)
			.not(icon)
			.not('input[type="text"]')
			.not('input[type="email"]')
			.not('button')
			.not('textarea')
			.not('i')
			.not('.' + wps_ff_data.prefix_dash + 'footer p')
			.not('.' + wps_ff_data.prefix_dash + 'powered-by p')
			.not('.' + wps_ff_data.prefix_dash + 'powered-by p a')
			.not('.' + wps_ff_data.prefix_dash + 'heading')
			.not('.' + wps_ff_data.prefix_dash + 'post-title a')
			.css('font-weight', wps_ff_data.font_weight);

		$(container).find('*')
			.not(show)
			.not(close)
			.not(icon)
			.not('.' + wps_ff_data.prefix_dash + 'heading')
			.not('input')
			.not('textarea')
			.not('i')
			//.not('.' + wps_ff_data.prefix_dash + 'list-item i')
			.not('i')
			.css('font-family', wps_ff_data.font_family);

		$('.' + wps_ff_data.prefix_dash + 'heading').css('font-family', wps_ff_data.heading_font_family);

		// Add position styling

		$(container).css('position', wps_ff_data.position);
		$(container).find('*')
			.not('a')
			.not('i')
			.not('input[type="text"]')
			.not('input[type="email"]')
			.not('textarea')
			.css('color', wps_ff_data.text_color);

		$(stub).css('position', wps_ff_data.position);

		// Add border styling

		$(show).css('border', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);

		add_container_border_style(location);

		// Add color styling

		$(container).css('background-color', wps_ff_data.color);
		$(container).find('a').css('color', wps_ff_data.link_color);

		$(show).css('background-color', wps_ff_data.color);
		$(text).css('color', wps_ff_data.text_color);
		$('.' + wps_ff_data.prefix_dash + 'close-button .fa-times').css('color', wps_ff_data.icon_color);
		$('.' + wps_ff_data.prefix_dash + 'link-button').css('color', wps_ff_data.link_text_color);

		$(show).css('color', wps_ff_data.icon_color);
		$(close).css('color', wps_ff_data.icon_color);
		$(icon).css('color', wps_ff_data.social_color);

		$(link_button).css('background-color', wps_ff_data.link_button_color);
		$(nl_button).css('background-color', wps_ff_data.nl_button_color);
		$(nl_button).css('color', wps_ff_data.nl_text_color);
		$(cu_button).css('background-color', wps_ff_data.nl_button_color);
		$(cu_button).css('color', wps_ff_data.nl_text_color);
	}

	/**
	 * Adds the right border style to the container
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function add_container_border_style(location){

		var container = '.' + wps_ff_data.prefix_dash + 'container';

		switch (location) {

			case '1':
				$(container).css('border-bottom', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-right', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '2':
				$(container).css('border-bottom', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-right', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-left', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '3':
				$(container).css('border-bottom', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-left', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '4':
				$(container).css('border-bottom', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-right', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-top', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '5':
				$(container).css('border', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '6':
				$(container).css('border-bottom', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-left', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-top', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '7':
				$(container).css('border-top', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-right', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '8':
				$(container).css('border-top', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-left', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-right', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			case '9':
				$(container).css('border-top', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				$(container).css('border-left', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;

			default:
				$(container).css('border', wps_ff_data.border_size + 'px solid ' + wps_ff_data.border_color);
				break;
		}
	}

	/**
	 * Adds a google font
	 *
	 * @access public
	 * @return void
	 */
	function wpsite_fire_flyout_add_google_font(font_family) {

		WebFont.load({
			google: {
			  families: [font_family]
			}
		});
	}

	/**
	 * Get all text nodes and wrap in p tags
	 *
	 * @access public
	 * @param mixed node
	 * @param mixed includeWhitespaceNodes
	 * @return void
	 */
	function wpsite_ff_getTextNodesIn(node, includeWhitespaceNodes) {
	    var textNodes = [], whitespace = /^\s*$/;

	    function wpsite_ff_getTextNodes(node) {
	        if (node.nodeType == 3) {
	            if (includeWhitespaceNodes || !whitespace.test(node.nodeValue)) {
	                textNodes.push(node);
	            }
	        } else {
	            for (var i = 0, len = node.childNodes.length; i < len; ++i) {
	                wpsite_ff_getTextNodes(node.childNodes[i]);
	            }
	        }
	    }

	    wpsite_ff_getTextNodes(node);
	    return textNodes;
	}
});