<?php
	//if uninstall not called from WordPress exit
	if ( !defined( 'WP_UNINSTALL_PLUGIN' ) )
		exit ();

	// Clear hook

	wp_clear_scheduled_hook('initialize_flyout_fire_stats_daily_cron');
	wp_clear_scheduled_hook('setup_flyout_fire_email_stats_cron');

	// Delete Data

	global $wpdb;

	include_once("admin/model/db.php");
	include_once("core/model/stats.php");
	include_once("core/model/email-signups.php");
	include_once("core/model/email-entries.php");

	$version_option_name = 'wpsite_flyout_fire_version';
	$license_key_name = 'wpsite_flyout_fire_license_key';

	if ( !is_multisite() ) {
		$wpdb->query('DROP TABLE `' . WPsite_Flyout_Fire_DB::getTableName() . '`');
		$wpdb->query('DROP TABLE `' . WPsite_Stats_FF::getTableName() . '`');
		$wpdb->query('DROP TABLE ' . WPsite_Email_Signups_FF::getTableName());
		$wpdb->query('DROP TABLE ' . WPsite_Email_Entries_FF::getTableName());

		delete_option($version_option_name);
		delete_option($license_key_name);
	} else {
	    $blog_ids = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs" );
	    $original_blog_id = get_current_blog_id();

	    foreach ( $blog_ids as $blog_id ) {
	        switch_to_blog( $blog_id );
	        $wpdb->query('DROP TABLE `' . WPsite_Flyout_Fire_DB::getTableName() . '`');
	        $wpdb->query('DROP TABLE `' . WPsite_Stats_FF::getTableName() . '`');
	        $wpdb->query('DROP TABLE ' . WPsite_Email_Signups_FF::getTableName());
	        $wpdb->query('DROP TABLE ' . WPsite_Email_Entries_FF::getTableName());
	    }

	    restore_current_blog();

	    delete_site_option($version_option_name);
	    delete_site_option($license_key_name);
	}

?>